summaryrefslogtreecommitdiffstats
path: root/13.37
diff options
context:
space:
mode:
author Eric Hameleers <alien@slackware.com>2013-09-18 20:40:29 +0000
committer Eric Hameleers <alien@slackware.com>2013-09-18 20:40:29 +0000
commitf75f0150df003d62c7b76b31e5b59fabdbc5d4ef (patch)
treeea3d0f9df1e97914f9e9a5ffe33c275afc715a91 /13.37
parentab3a0590b302b00a6bdec12d802d8091f288ff21 (diff)
downloadmultilib-f75f0150df003d62c7b76b31e5b59fabdbc5d4ef.tar.gz
multilib-f75f0150df003d62c7b76b31e5b59fabdbc5d4ef.tar.xz
Updated with new way to generate the zoneinfo database; also provide patch for CVE-2013-4332
Diffstat (limited to '13.37')
-rwxr-xr-x13.37/glibc/glibc-multilib.SlackBuild45
1 files changed, 28 insertions, 17 deletions
diff --git a/13.37/glibc/glibc-multilib.SlackBuild b/13.37/glibc/glibc-multilib.SlackBuild
index e9c05f9..03cf5d8 100755
--- a/13.37/glibc/glibc-multilib.SlackBuild
+++ b/13.37/glibc/glibc-multilib.SlackBuild
@@ -1,6 +1,6 @@
#!/bin/sh
-# Copyright 2006, 2008, 2009, 2010, 2011, 2012 Patrick J. Volkerding, Sebeka, MN, USA
+# Copyright 2006, 2008, 2009, 2010, 2011, 2012, 2013 Patrick J. Volkerding, Sebeka, MN, USA
# All rights reserved.
#
# Redistribution and use of this script, with or without modification, is
@@ -30,7 +30,7 @@
VERSION=${VERSION:-2.13}
CHECKOUT=${CHECKOUT:-""}
-BUILD=${BUILD:-6alien}
+BUILD=${BUILD:-7alien}
## Included in glibc now:
## glibc-libidn version
@@ -194,25 +194,14 @@ apply_patches() {
zcat $CWD/glibc.CVE-2009-5029.diff.gz | patch -p1 --verbose || exit 1
# Fix strtod overflows:
zcat $CWD/glibc-2.13.strtod.CVE-2012-3480.diff.gz | patch -p1 --verbose || exit 1
+ # Patch integer overflows in pvalloc, valloc, and
+ # posix_memalign/memalign/aligned_alloc (CVE-2013-4332).
+ zcat $CWD/glibc.CVE-2013-4332.diff.gz | patch -p1 --verbose || exit 1
if [ $BOOTSTRP -eq 1 ] ; then
# Multilib - Disable check for forced unwind (Patch from eglibc) since we
# do not have a multilib glibc yet to link to;
zcat $CWD/glibc.pthread-disable-forced-unwind-check.diff.gz | patch -p1 --verbose || exit 1
fi
- # Update the timezone information.
- ( cd timezone
- tar xzf $CWD/tzdata?????.tar.gz
- chown root:root *
- mv yearistype.sh yearistype
- chmod 644 *
- chmod 755 yearistype
- mkdir tzcode
- cd tzcode
- tar xzf $CWD/tzcode?????.tar.gz
- chown -R root:root .
- chmod 644 *
- cp -a *.c *.h ..
- )
}
# This is going to be the initial $DESTDIR:
@@ -352,6 +341,25 @@ strip -g $PKG/lib${LIBDIRSUFFIX}/l*.so*
strip -g $PKG/usr/lib${LIBDIRSUFFIX}/l*.so*
strip -g $PKG/usr/lib${LIBDIRSUFFIX}/lib*.a
+# Build and install the zoneinfo database:
+cd $TMP
+rm -rf tzcodedata-build
+mkdir tzcodedata-build
+cd tzcodedata-build
+tar xzf $CWD/tzdata?????.tar.gz
+tar xzf $CWD/tzcode?????.tar.gz
+sed -i "s,/usr/local,$(pwd),g" Makefile
+sed -i "s,/etc/zoneinfo,/zoneinfo,g" Makefile
+make
+make install
+mkdir -p $PKG/usr/share/zoneinfo/{posix,right}
+cp -a zoneinfo/* $PKG/usr/share/zoneinfo
+cp -a zoneinfo-posix/* $PKG/usr/share/zoneinfo/posix
+cp -a zoneinfo-leaps/* $PKG/usr/share/zoneinfo/right
+# Remove $PKG/usr/share/zoneinfo/localtime -- the install script will
+# create it as a link to /etc/localtime.
+rm -f $PKG/usr/share/zoneinfo/localtime
+
# Back to the sources dir to add some files/docs:
cd $TMP/glibc-$CVSVER
@@ -422,6 +430,9 @@ rm $PKG/etc/ld.so.cache
##################################
# glibc-zoneinfo. We will start with an easy one to avoid breaking a sweat ;-)
+cd $CWD
+ZONE_VERSIONS="$(echo tzdata* | cut -f1 -d . | cut -b7-11)"
+echo $ZONE_VERSIONS
cd $PZONE
# Install some scripts to help select a timezone:
mkdir -p $PZONE/var/log/setup
@@ -443,7 +454,7 @@ mkdir -p $PZONE/etc
# This is already hard-coded into doinst.sh (like it'll be there anyway ;-):
rm -f etc/localtime
# Wrap it up:
-/sbin/makepkg -l y -c n $TMP/glibc-zoneinfo-${VERSION}_multilib-noarch-$BUILD.txz
+/sbin/makepkg -l y -c n $TMP/glibc-zoneinfo-${ZONE_VERSIONS}_multilib-noarch-$BUILD.txz
# glibc-profile:
cd $PPROFILE